#include "crc.h"

// 16 Bit CRC Qƃe[u쐬
void CCrc16::MakeCrcTable() throw (std::bad_alloc)
{
	unsigned long int  nCrc;
	              int  i, j;
	unsigned      char cValue;

	// CRC Qƃe[ũm
	NEWARRAY(m_lpnCrcTable, unsigned long int, UCHAR_MAX + 1);

	if (m_nBitShift)
		// rbgȄꍇ
		for (i = 0; i < UCHAR_MAX + 1; i ++)
		{
			nCrc   = 0;
			cValue = (unsigned char)i;

			for (j = 0; j < CHAR_BIT; j ++)
			{
				if ((cValue & 0x01U) ^ (nCrc & 0x00000001U))
				{
					nCrc >>= 1;
					nCrc  ^= m_nCrcPoly;
				}
				else
					nCrc >>= 1;

				cValue >>= 1;
			}
			m_lpnCrcTable[i] = (unsigned short int)nCrc;
		}
	else
		// rbg̏ꍇ
		for (i = 0; i < UCHAR_MAX + 1; i ++)
		{
			nCrc   = 0;
			cValue = (unsigned char)i;

			for (j = 0; j < CHAR_BIT; j ++)
			{
				if (((cValue & 0x80U) << CHAR_BIT) ^ (nCrc & 0x00008000U))
				{
					nCrc <<= 1;
					nCrc  ^= m_nCrcPoly;
				}
				else
					nCrc <<= 1;

				cValue <<= 1;
			}
			m_lpnCrcTable[i] = (unsigned short int)nCrc;
		}
}

// 16 Bit CRC vZ
void CCrc16::Calc(unsigned char cValue)
{
	if (m_nBitShift)
		// rbgȄꍇ
		m_nCrcValue = (((unsigned short int)m_nCrcValue) >> CHAR_BIT) ^ 
			m_lpnCrcTable[((unsigned char)m_nCrcValue) ^ cValue];
	else
		// rbg̏ꍇ
		m_nCrcValue = (((unsigned short int)m_nCrcValue) << CHAR_BIT) ^ 
			m_lpnCrcTable[((unsigned char)(m_nCrcValue >> CHAR_BIT)) ^ cValue];
}

// 32 Bit CRC Qƃe[u쐬
void CCrc32::MakeCrcTable() throw (std::bad_alloc)
{
	unsigned long int  nCrc;
				  int  i, j;
	unsigned      char cValue;

	NEWARRAY(m_lpnCrcTable, unsigned long int, UCHAR_MAX + 1);

	if (m_nBitShift)
		// rbgȄꍇ
		for (i = 0; i < UCHAR_MAX + 1; i ++)
		{
			nCrc   = 0;
			cValue = (unsigned char)i;

			for (j = 0; j < CHAR_BIT; j ++)
			{
				if ((cValue & 0x01U) ^ (nCrc & 0x00000001U))
				{
					nCrc >>= 1;
					nCrc  ^= m_nCrcPoly;
				}
				else
					nCrc >>= 1;

				cValue >>= 1;
			}
			m_lpnCrcTable[i] = nCrc;
		}
	else
		// rbg̏ꍇ
		for (i = 0; i < UCHAR_MAX + 1; i ++)
		{
			nCrc   = 0;
			cValue = (unsigned char)i;

			for (j = 0; j < CHAR_BIT; j ++)
			{
				if (((cValue & 0x80U) << CHAR_BIT * 3) ^ (nCrc & 0x80000000U))
				{
					nCrc <<= 1;
					nCrc  ^= m_nCrcPoly;
				}
				else
					nCrc <<= 1;

				cValue <<= 1;
			}
			m_lpnCrcTable[i] = nCrc;
		}
}

// 32 Bit CRC vZ
void CCrc32::Calc(unsigned char cValue)
{
	if (m_nBitShift)
		// rbgȄꍇ
		m_nCrcValue = (m_nCrcValue >> CHAR_BIT) ^ 
			m_lpnCrcTable[((unsigned char)m_nCrcValue) ^ cValue];
	else
		// rbg̏ꍇ
		m_nCrcValue = (m_nCrcValue << CHAR_BIT) ^ 
			m_lpnCrcTable[((unsigned char)(m_nCrcValue >> CHAR_BIT * 3)) ^ cValue];
}
